/*
 created by:
     /\            888                   888     .d8888b.   .d8888b.  
____/_ \____       888                   888    d88P  Y88b d88P  Y88b 
\  ___\ \  /       888                   888    888    888 888    888 
 \/ /  \/ /    .d88888  8888b.   8888b.  888888 Y88b. d888 Y88b. d888 
 / /\__/_/\   d88" 888     "88b     "88b 888     "Y888P888  "Y888P888 
/__\ \_____\  888  888 .d888888 .d888888 888           888        888 
    \  /      Y88b 888 888  888 888  888 Y88b.  Y88b  d88P Y88b  d88P 
     \/        "Y88888 "Y888888 "Y888888  "Y888  "Y8888P"   "Y8888P"  
*/
using System;

namespace Server.Items
{
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class PineBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PineBoard" : "{0} PineBoards", Amount );
			}
		}

		[Constructable]
		public PineBoard() : this(1)
		{
		}

		[Constructable]
		public PineBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Pine Board";
			Hue = 1262;
			Weight = 0.1;
			Amount = amount;
		}

		public PineBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new PineBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class AshBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} AshBoard" : "{0} AshBoards", Amount );
			}
		}

		[Constructable]
		public AshBoard() : this(1)
		{
		}

		[Constructable]
		public AshBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Ash Board";
			Hue = 961;
			Weight = 0.1;
			Amount = amount;
		}

		public AshBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new AshBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class MohoganyBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} MohoganyBoard" : "{0} MohoganyBoards", Amount );
			}
		}

		[Constructable]
		public MohoganyBoard() : this(1)
		{
		}

		[Constructable]
		public MohoganyBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Mohogany Board";
			Hue = 355;
			Weight = 0.1;
			Amount = amount;
		}

		public MohoganyBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new MohoganyBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class YewBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} YewBoard" : "{0} YewBoards", Amount );
			}
		}

		[Constructable]
		public YewBoard() : this(1)
		{
		}

		[Constructable]
		public YewBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Yew Board";
			Hue = 1281;
			Weight = 0.1;
			Amount = amount;
		}

		public YewBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new YewBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class OakBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} OakBoard" : "{0} OakBoards", Amount );
			}
		}

		[Constructable]
		public OakBoard() : this(1)
		{
		}

		[Constructable]
		public OakBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Oak Board";
			Hue = 488;
			Weight = 0.1;
			Amount = amount;
		}

		public OakBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new OakBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class ZircoteBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} ZircoteBoard" : "{0} ZircoteBoards", Amount );
			}
		}

		[Constructable]
		public ZircoteBoard() : this(1)
		{
		}

		[Constructable]
		public ZircoteBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Zircote Board";
			Hue = 1271;
			Weight = 0.1;
			Amount = amount;
		}

		public ZircoteBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new ZircoteBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class EbonyBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} EbonyBoard" : "{0} EbonyBoards", Amount );
			}
		}

		[Constructable]
		public EbonyBoard() : this(1)
		{
		}

		[Constructable]
		public EbonyBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Ebony Board";
			Hue = 43;
			Weight = 0.1;
			Amount = amount;
		}

		public EbonyBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new EbonyBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class BambooBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} BambooBoard" : "{0} BambooBoards", Amount );
			}
		}

		[Constructable]
		public BambooBoard() : this(1)
		{
		}

		[Constructable]
		public BambooBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Bamboo Board";
			Hue = 1152;
			Weight = 0.1;
			Amount = amount;
		}

		public BambooBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new BambooBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class PurpleHeartBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PurpleHeartBoard" : "{0} PurpleHeartBoards", Amount );
			}
		}

		[Constructable]
		public PurpleHeartBoard() : this(1)
		{
		}

		[Constructable]
		public PurpleHeartBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "PurpleHeart Board";
			Hue = 114;
			Weight = 0.1;
			Amount = amount;
		}

		public PurpleHeartBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new PurpleHeartBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class RedwoodBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} RedwoodBoard" : "{0} RedwoodBoards", Amount );
			}
		}

		[Constructable]
		public RedwoodBoard() : this(1)
		{
		}

		[Constructable]
		public RedwoodBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Redwood Board";
			Hue = 37;
			Weight = 0.1;
			Amount = amount;
		}

		public RedwoodBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new RedwoodBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	
	[FlipableAttribute(0x1BD7, 0x1BDA)]
	public class PetrifiedBoard : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PetrifiedBoard" : "{0} PetrifiedBoards", Amount );
			}
		}

		[Constructable]
		public PetrifiedBoard() : this(1)
		{
		}

		[Constructable]
		public PetrifiedBoard(int amount) : base(0x1BD7)
		{
			Stackable = true;
			Name = "Petrified Board";
			Hue = 1153;
			Weight = 0.1;
			Amount = amount;
		}

		public PetrifiedBoard(Serial serial) : base(serial)
		{
		}

		// public override Item Dupe(int amount)
		// {
			// return base.Dupe(new PetrifiedBoard(amount), amount);
		// }

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class PineLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PineLog" : "{0} PineLogs", Amount );
			}
		}

		[Constructable]
		public PineLog() : this( 1 )
		{
		}

		[Constructable]
		public PineLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Pine Log";
			Hue = 1262; 
			Weight = 2.0;
			Amount = amount;
		}

		public PineLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new PineLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class AshLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} AshLog" : "{0} AshLogs", Amount );
			}
		}

		[Constructable]
		public AshLog() : this( 1 )
		{
		}

		[Constructable]
		public AshLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Ash Log";
			Hue = 961; 
			Weight = 2.0;
			Amount = amount;
		}

		public AshLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new AshLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class MohoganyLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} MohoganyLog" : "{0} MohoganyLogs", Amount );
			}
		}

		[Constructable]
		public MohoganyLog() : this( 1 )
		{
		}

		[Constructable]
		public MohoganyLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Mohogany Log";
			Hue = 355; 
			Weight = 2.0;
			Amount = amount;
		}

		public MohoganyLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new MohoganyLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class YewLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} YewLog" : "{0} YewLogs", Amount );
			}
		}

		[Constructable]
		public YewLog() : this( 1 )
		{
		}

		[Constructable]
		public YewLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Yew Log";
			Hue = 1281; 
			Weight = 2.0;
			Amount = amount;
		}

		public YewLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new YewLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class OakLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} OakLog" : "{0} OakLogs", Amount );
			}
		}

		[Constructable]
		public OakLog() : this( 1 )
		{
		}

		[Constructable]
		public OakLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Oak Log";
			Hue = 488; 
			Weight = 2.0;
			Amount = amount;
		}

		public OakLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new OakLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class ZircoteLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} ZircoteLog" : "{0} ZircoteLogs", Amount );
			}
		}

		[Constructable]
		public ZircoteLog() : this( 1 )
		{
		}

		[Constructable]
		public ZircoteLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Zircote Log";
			Hue = 1271; 
			Weight = 2.0;
			Amount = amount;
		}

		public ZircoteLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new ZircoteLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class EbonyLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} EbonyLog" : "{0} EbonyLogs", Amount );
			}
		}

		[Constructable]
		public EbonyLog() : this( 1 )
		{
		}

		[Constructable]
		public EbonyLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Ebony Log";
			Hue = 43; 
			Weight = 2.0;
			Amount = amount;
		}

		public EbonyLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new EbonyLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class BambooLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} BambooLog" : "{0} BambooLogs", Amount );
			}
		}

		[Constructable]
		public BambooLog() : this( 1 )
		{
		}

		[Constructable]
		public BambooLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Bamboo Log";
			Hue = 1152; 
			Weight = 2.0;
			Amount = amount;
		}

		public BambooLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new BambooLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class PurpleHeartLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PurpleHeartLog" : "{0} PurpleHeartLogs", Amount );
			}
		}

		[Constructable]
		public PurpleHeartLog() : this( 1 )
		{
		}

		[Constructable]
		public PurpleHeartLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "PurpleHeart Log";
			Hue = 114; 
			Weight = 2.0;
			Amount = amount;
		}

		public PurpleHeartLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new PurpleHeartLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class RedwoodLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} RedwoodLog" : "{0} RedwoodLogs", Amount );
			}
		}

		[Constructable]
		public RedwoodLog() : this( 1 )
		{
		}

		[Constructable]
		public RedwoodLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Redwood Log";
			Hue = 37; 
			Weight = 2.0;
			Amount = amount;
		}

		public RedwoodLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new RedwoodLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	[FlipableAttribute( 0x1bdd, 0x1be0 )]
	public class PetrifiedLog : Item, ICommodity
	{
		string ICommodity.Description
		{
			get
			{
				return String.Format( Amount == 1 ? "{0} PetrifiedLog" : "{0} PetrifiedLogs", Amount );
			}
		}

		[Constructable]
		public PetrifiedLog() : this( 1 )
		{
		}

		[Constructable]
		public PetrifiedLog( int amount ) : base( 0x1BDD )
		{
			Stackable = true;
			Name = "Petrified Log";
			Hue = 1153; 
			Weight = 2.0;
			Amount = amount;
		}

		public PetrifiedLog( Serial serial ) : base( serial )
		{
		}

		// public override Item Dupe( int amount )
		// {
			// return base.Dupe( new PetrifiedLog( amount ), amount );
		// }

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}