/*
 created by:
     /\            888                   888     .d8888b.   .d8888b.  
____/_ \____       888                   888    d88P  Y88b d88P  Y88b 
\  ___\ \  /       888                   888    888    888 888    888 
 \/ /  \/ /    .d88888  8888b.   8888b.  888888 Y88b. d888 Y88b. d888 
 / /\__/_/\   d88" 888     "88b     "88b 888     "Y888P888  "Y888P888 
/__\ \_____\  888  888 .d888888 .d888888 888           888        888 
    \  /      Y88b 888 888  888 888  888 Y88b.  Y88b  d88P Y88b  d88P 
     \/        "Y88888 "Y888888 "Y888888  "Y888  "Y8888P"   "Y8888P"  
*/
using System; 
using System.Collections;
using Server; 
using Server.Commands;
using Server.daat99;
using Server.Engines.BulkOrders;
using Server.Gumps; 
using Server.Items;
using Server.Mobiles;
using Server.Network;

namespace Server.daat99
{
	public class Daat99CustomOWLTRGump : Gump 
	{
		private bool b_ForStaff;
		private PlayerMobile p_From;

		public Daat99CustomOWLTRGump( PlayerMobile from ) : base( 100, 100 ) 
		{
			p_From = from;
			if (from.AccessLevel >= AccessLevel.Administrator)
				b_ForStaff = true;
			else
				b_ForStaff = false;

			AddPage( 0 ); 
			AddBackground( 0, 0, 560, 480, 3500 ); //white

			AddHtml( 65, 15, 450, 20, "<basefont color=#ff0000>Daat99's O.W.L.T.R (RunUO 2.0 Mods by Lokai) v3.00 Control Center:</basefont>", false, false ); 

			AddLabel(15,  40, 2, @"===================");
			AddLabel(55,  50, 2, @" /\");
			AddLabel(16,  60, 2, @" -----/---\-----");
			AddLabel(20,  70, 2, @" \ /     \ /");
			AddLabel(28,  80, 2, @" /       \");
			AddLabel(30,  80, 2, @" \       /");
			AddLabel(19,  90, 2, @" / \     / \");
			AddLabel(17, 100, 2, @" -----\---/-----");
			AddLabel(57, 110, 2, @" \/");
			AddLabel(15, 120, 2, @"===================");
			
			AddButton( 160, 40, 5526, 5527, 999, GumpButtonType.Reply, 0 ); //web site

			AddLabel( 155, 68, 1263, "Hall of Helpers" );
			AddButton( 135, 70, 4033, 4033, 101, GumpButtonType.Page, 1 );

			Daat99OWLTR.OwltrOps[] OwltrOps = Daat99OWLTR.Ops;	

			AddLabel( 35, 138, 70, @"Ubber Resources & Harvesting" );
			AddButton( 15, 140, 4033, 4033, 102, GumpButtonType.Page, 2 );

			AddLabel( 35, 158, 70, @"A_Li_N's Clean Champ" );
			AddButton( 15, 160, 4033, 4033, 103, GumpButtonType.Page, 3 );

			AddLabel( 35, 178, 70, @"Custom Craftables" );
			AddButton( 15, 180, 4033, 4033, 104, GumpButtonType.Page, 4 );

			AddLabel( 35, 198, 70, @"MuleForge\RunicJewls\RegsKeys" );
			AddButton( 15, 200, 4033, 4033, 105, GumpButtonType.Page, 5 );
			
			AddLabel( 35, 218, 70, @"Monsters and BoDs Tokens" );
			AddButton( 15, 220, 4033, 4033, 106, GumpButtonType.Page, 6 );

			AddLabel( 35, 238, 70, @"Harvesting and Crafting Tokens" );
			AddButton( 15, 240, 4033, 4033, 107, GumpButtonType.Page, 7 );

			AddLabel( 35, 258, 70, @"Recipe Crafting" );
			AddButton( 15, 260, 4033, 4033, 108, GumpButtonType.Page, 8 );

			AddLabel( 35, 278, 70, @"Resource Cost and Lottery\Exchange" );
			AddButton( 15, 280, 4033, 4033, 109, GumpButtonType.Page, 9 );

			AddLabel( 35, 298, 70, @"Safe Trash 4 Tokens Bag Settings" );
			AddButton( 15, 300, 4033, 4033, 110, GumpButtonType.Page, 10 );

			///DO NOT CHANGE THIS LINES
			AddPage( 1 ); //hall of helpers
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 45, 285, 20, String.Format( "<basefont color=#ff00ff>Hall of Helpers:</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 65, 285, 40, String.Format( "<basefont color=#ff0000>I like to say Thanks to my fellow RunUO members:</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 105, 285, 220, String.Format( "<basefont color=#0000ff>UOT, ArteGordon, Guadah, Ashenfall, Ashlars and his beloved Morrigan, beau, Raider, Liam, telekea, porker, A_Li_N, Roseanne, RANCID77, Tark, n0brain, Arthemis, jjarmis, ssalter, Raelis, Briseis, Rift, bzk90, RoninGT, Memnoch, feralfreak, DaZiL, joshw, Greystar, XxSP1DERxX, Joeku, Freya, francecio, pvtjoker, Kiki, Viago, ChaosSally, Khephren, awakenlands, ChaosSally, Sotho Tal Ker, Wilcard, Beldr, Thundar, TesterSam, CynsPixie, Sunshine, TMSTKSBK, artio, Turmoil, KatNyte, Jakob, STalKer-X, ASayre8, alexander, Bham, toddjumper, Arvoreen, IndigoParadox, MatrixMan, Jebbit, Sorious, AdminVile, arul, RipRizzle.</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 345, 285, 40, String.Format( "<basefont color=#ff0000>I like to say Thanks to Allure of the Unknown members:</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 385, 285, 20, String.Format( "<basefont color=#0000ff> Kiara, Joe, Tark, Vellendarl.</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 405, 285, 40, String.Format( "<basefont color=#ff0000>I like to say Thanks to Swordhaven members:</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			AddHtml( 260, 425, 285, 20, String.Format( "<basefont color=#0000ff> Wimpy, Limpy, JJ.</font>" ), false, false );
			///DO NOT CHANGE THIS LINES
			///DO NOT CHANGE THIS LINES
			
			AddPage( 2 ); 
			//ubber resources
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[0].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 1, GumpButtonType.Reply, 0 );
			if (OwltrOps[0].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 20, String.Format( "<basefont color=#ff0000>Require server restart.</font>" ), false, false );
			AddHtml( 260, 75, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[0].Desctiption ), false, false );
			// mining
			AddHtml( 260, 175, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[1].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 175, 2511, 2510, 2, GumpButtonType.Reply, 0 );
			if (OwltrOps[1].Setting == true)
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 195, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[1].Desctiption ), false, false );
			// lumberjacking
			AddHtml( 260, 325, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[2].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 325, 2511, 2510, 3, GumpButtonType.Reply, 0 );
			if (OwltrOps[2].Setting == true)
				AddHtml( 435, 325, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 325, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 345, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[2].Desctiption ), false, false );

			AddPage( 3 );
			//A_Li_N clean champ
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[3].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 4, GumpButtonType.Reply, 0 );
			if (OwltrOps[3].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[3].Desctiption ), false, false );
			//A_Li_N 
			AddHtml( 260, 175, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[4].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 175, 2511, 2510, 5, GumpButtonType.Reply, 0 );
			if (OwltrOps[4].Setting == true)
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 195, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[4].Desctiption ), false, false );
			
			AddPage( 4 ); //custom craftables
			//BankHive
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[6].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 7, GumpButtonType.Reply, 0 );
			if (OwltrOps[6].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[6].Desctiption ), false, false );
			//Tool Runic House
			AddHtml( 260, 135, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[7].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 135, 2511, 2510, 8, GumpButtonType.Reply, 0 );
			if (OwltrOps[7].Setting == true)
				AddHtml( 435, 135, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 135, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 155, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[7].Desctiption ), false, false );
			//Mobile Forge
			AddHtml( 260, 255, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[8].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 255, 2511, 2510, 9, GumpButtonType.Reply, 0 );
			if (OwltrOps[8].Setting == true)
				AddHtml( 435, 255, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 255, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 275, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[8].Desctiption ), false, false );
			//Resource Keys
			AddHtml( 260, 355, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[9].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 355, 2511, 2510, 10, GumpButtonType.Reply, 0 );
			if (OwltrOps[9].Setting == true)
				AddHtml( 435, 355, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 355, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 375, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[9].Desctiption ), false, false );

			AddPage( 5 );
			//Forge Mule
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[10].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 11, GumpButtonType.Reply, 0 );
			if (OwltrOps[10].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[10].Desctiption ), false, false );
			//Runic Jewlery 
			AddHtml( 260, 175, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[11].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 175, 2511, 2510, 12, GumpButtonType.Reply, 0 );
			if (OwltrOps[11].Setting == true)
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 195, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[11].Desctiption ), false, false );
			//Spellcasters Key Reagents
			AddHtml( 260, 315, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[12].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 315, 2511, 2510, 13, GumpButtonType.Reply, 0 );
			if (OwltrOps[12].Setting == true)
				AddHtml( 435, 315, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 315, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 335, 285, 120, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[12].Desctiption ), false, false );
			
			AddPage( 6 );
			//Monster Give Tokens
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[13].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 14, GumpButtonType.Reply, 0 );
			if (OwltrOps[13].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[13].Desctiption ), false, false );
			//Bod Give Tokens 
			AddHtml( 260, 175, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[14].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 175, 2511, 2510, 15, GumpButtonType.Reply, 0 );
			if (OwltrOps[14].Setting == true)
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 175, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 195, 285, 130, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[14].Desctiption ), false, false );
			
			AddPage( 7 );
			//Harvest Give Tokens
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[15].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 16, GumpButtonType.Reply, 0 );
			if (OwltrOps[15].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 200, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[15].Desctiption ), false, false );
			//Craft Give Tokens 
			AddHtml( 260, 255, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[16].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 255, 2511, 2510, 17, GumpButtonType.Reply, 0 );
			if (OwltrOps[16].Setting == true)
				AddHtml( 435, 255, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 255, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 275, 285, 160, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[16].Desctiption ), false, false );
			
			AddPage( 8 );
			//Recipe Craft
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[5].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 6, GumpButtonType.Reply, 0 );
			if (OwltrOps[5].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 60, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[5].Desctiption ), false, false );
			//DedicationRecipes
			AddHtml( 260, 125, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[28].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 125, 2511, 2510, 29, GumpButtonType.Reply, 0 );
			if (OwltrOps[28].Setting == true)
				AddHtml( 435, 125, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 125, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 145, 285, 60, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[28].Desctiption ), false, false );

			//crafts
			AddHtml( 260, 225, 285, 20, @"<basefont color=#ff0000>Enable\Disable each craft individualy:</font>", false, false );
			//alchemy
			AddHtml( 260, 245, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[17].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 245, 2511, 2510, 18, GumpButtonType.Reply, 0 );
			if (OwltrOps[17].Setting == true)
				AddHtml( 435, 245, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 245, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Blacksmithy
			AddHtml( 260, 265, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[18].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 265, 2511, 2510, 19, GumpButtonType.Reply, 0 );
			if (OwltrOps[18].Setting == true)
				AddHtml( 435, 265, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 265, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//BowFletching
			AddHtml( 260, 285, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[19].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 285, 2511, 2510, 20, GumpButtonType.Reply, 0 );
			if (OwltrOps[19].Setting == true)
				AddHtml( 435, 285, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 285, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Carpentry
			AddHtml( 260, 305, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[20].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 305, 2511, 2510, 21, GumpButtonType.Reply, 0 );
			if (OwltrOps[20].Setting == true)
				AddHtml( 435, 305, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 305, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Cooking
			AddHtml( 260, 325, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[21].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 325, 2511, 2510, 22, GumpButtonType.Reply, 0 );
			if (OwltrOps[21].Setting == true)
				AddHtml( 435, 325, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 325, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Glassblowing
			AddHtml( 260, 345, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[22].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 345, 2511, 2510, 23, GumpButtonType.Reply, 0 );
			if (OwltrOps[22].Setting == true)
				AddHtml( 435, 345, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 345, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Inscription
			AddHtml( 260, 365, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[23].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 365, 2511, 2510, 24, GumpButtonType.Reply, 0 );
			if (OwltrOps[23].Setting == true)
				AddHtml( 435, 365, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 365, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Masonry
			AddHtml( 260, 385, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[24].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 385, 2511, 2510, 25, GumpButtonType.Reply, 0 );
			if (OwltrOps[24].Setting == true)
				AddHtml( 435, 385, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 385, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Glassblowing
			AddHtml( 260, 405, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[25].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 405, 2511, 2510, 26, GumpButtonType.Reply, 0 );
			if (OwltrOps[25].Setting == true)
				AddHtml( 435, 405, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 405, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Inscription
			AddHtml( 260, 425, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[26].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 425, 2511, 2510, 27, GumpButtonType.Reply, 0 );
			if (OwltrOps[26].Setting == true)
				AddHtml( 435, 425, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 425, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			//Resources
			AddHtml( 260, 445, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[27].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 445, 2511, 2510, 28, GumpButtonType.Reply, 0 );
			if (OwltrOps[27].Setting == true)
				AddHtml( 435, 445, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 445, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );

			AddPage( 9 );
			//Resource Cost
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>{0}:</font>", OwltrOps[29].Title ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 30, GumpButtonType.Reply, 0 );
			if (OwltrOps[29].Setting == true)
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 100, String.Format( "<basefont color=#0000ff>{0}</font>", OwltrOps[29].Desctiption ), false, false );
			//Tokens Lottery
			AddHtml( 260, 180, 145, 20, String.Format( "<basefont color=#111111>Tokens Lottery</font>" ), false, false );
			if (b_ForStaff) AddButton( 415, 180, 2511, 2510, 998, GumpButtonType.Reply, 0 );
			if (LadyLuck.EnableLottery)
				AddHtml( 435, 180, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 180, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 200, 285, 100, String.Format( "<basefont color=#0000ff>When enabled it'll allow players to buy lottery tickets from lady luck. <br>It won't effect tickets that were sold already and Lady Luck will accept that last drawing tickets as usuall.</font>" ), false, false );
			//Tokens Exchange
			AddHtml( 260, 320, 145, 20, String.Format( "<basefont color=#111111>Tokens Exchange</font>" ), false, false );
			if (b_ForStaff) AddButton( 415, 320, 2511, 2510, 997, GumpButtonType.Reply, 0 );
			if (LadyLuck.EnableExchange)
				AddHtml( 435, 320, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 320, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 340, 285, 100, String.Format( "<basefont color=#0000ff>When enabled it'll allow players to exchange gold for tokens and tokens for gold.</font>" ), false, false );
			AddHtml( 260, 380, 240, 20, String.Format( "<basefont color=#111111>Each token cost " + LadyLuck.TokenCostInGold + " gold coins.</font>" ), false, false );
			if (b_ForStaff)
			{
				AddLabel( 305, 415, 20, "Set a new price:");
				AddTextEntry( 415, 417, 90, 20, 32, 996, LadyLuck.TokenCostInGold.ToString() );
				AddButton( 260, 407, 2642, 2643, 995, GumpButtonType.Reply, 0);
			}

			AddPage( 10 );
			
//Trash Gold OK?
			AddHtml( 260, 35, 145, 20, String.Format( "<basefont color=#111111>Trash Gold OK?:</font>" ), false, false );
			if (b_ForStaff) AddButton( 415, 35, 2511, 2510, 993, GumpButtonType.Reply, 0 );
			if ( LadyLuck.TrashGoldOK )
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 35, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 55, 285, 40, String.Format( "<basefont color=#0000ff>When enabled, Gold may not be placed in the bag.</font>" ), false, false );
			
//Trash Tokens OK?
			AddHtml( 260, 105, 145, 20, String.Format( "<basefont color=#111111>Trash Tokens OK?:</font>" ), false, false );
			if (b_ForStaff) AddButton( 415, 105, 2511, 2510, 992, GumpButtonType.Reply, 0 );
			if ( LadyLuck.TrashTokensOK )
				AddHtml( 435, 105, 145, 20, String.Format( "<basefont color=#008800>Currently enabled.</font>" ), false, false );
			else
				AddHtml( 435, 105, 145, 20, String.Format( "<basefont color=#ff0000>Currently disabled.</font>" ), false, false );
			AddHtml( 260, 125, 285, 40, String.Format( "<basefont color=#0000ff>When enabled, Tokens may not be placed in the bag.</font>" ), false, false );
			
//Safe Trash 4 Tokens Time
			AddHtml( 260, 175, 145, 20, String.Format( "<basefont color=#111111>Safe Trash 4 Tokens Time</font>" ), false, false );
			AddHtml( 260, 195, 285, 40, String.Format( "<basefont color=#0000ff>This is the # of minutes the Trash 4 Tokens Bag will hold items before clearing them.</font>" ), false, false );
			AddHtml( 260, 245, 240, 20, String.Format( "<basefont color=#111111>Currently set to " + LadyLuck.SafeBagMinutes + " Minutes.</font>" ), false, false );
			if (b_ForStaff)
			{
				AddLabel( 305, 280, 20, "Set #Min until Trash Empties:");
				AddTextEntry( 515, 280, 90, 20, 32, 991, LadyLuck.SafeBagMinutes.ToString() );
				AddButton( 260, 272, 2642, 2643, 990, GumpButtonType.Reply, 0);
			}
			
//Safe Bag Weight Reduction %
			AddHtml( 260, 330, 145, 20, String.Format( "<basefont color=#111111>Safe Bag Wieght Reduction %</font>" ), false, false );
			AddHtml( 260, 350, 285, 40, String.Format( "<basefont color=#0000ff>This is the % of weight the bag reduces items. 0 - means no change. 100 - means no weight.</font>" ), false, false );
			AddHtml( 260, 390, 240, 20, String.Format( "<basefont color=#111111>Currently set to " + LadyLuck.SafeBagWeightPercent + "%.</font>" ), false, false );
			if (b_ForStaff)
			{
				AddLabel( 305, 425, 20, "Set % of weight the bag reduces:");
				AddTextEntry( 515, 425, 90, 20, 32, 989, LadyLuck.SafeBagWeightPercent.ToString() );
				AddButton( 260, 417, 2642, 2643, 988, GumpButtonType.Reply, 0);
			}
		}

		public override void OnResponse(NetState state, RelayInfo info)
		{
			Daat99OWLTR.OwltrOps[] OwltrOps = Daat99OWLTR.Ops;
			Mobile from = state.Mobile;
			if (info.ButtonID == 999)
				from.LaunchBrowser( "http://www.angelfire.com/trek/daat99/index.html" );
			else if (!b_ForStaff)
				return;
			else if (info.ButtonID >= 1 && info.ButtonID <= OwltrOps.Length)
				OwltrOps[info.ButtonID-1].Setting = !(OwltrOps[info.ButtonID-1].Setting);
			else if (info.ButtonID == 998)
				LadyLuck.EnableLottery = !LadyLuck.EnableLottery;
			else if (info.ButtonID == 997)
				LadyLuck.EnableExchange = !LadyLuck.EnableExchange;
			else if (info.ButtonID == 995)
			{
				TextRelay tr_Text = info.GetTextEntry( 996 );
				if(tr_Text != null)
				{
					int iNewPrice = 0;
					try { iNewPrice = Convert.ToInt32(tr_Text.Text,10); } 
					catch { from.SendMessage("Please make sure you wrote only numbers."); }
					if (iNewPrice > 60000)
						from.SendMessage( 32, "You can't set the price for more then 60k gold per token." );
					else if (iNewPrice > 0)
					{
						LadyLuck.TokenCostInGold = iNewPrice;
						from.SendMessage( 88, "You set a new price for tokens, from now on each tokens will be exchanged for {0} gold", iNewPrice );
					}
				}
			}
			else if (info.ButtonID == 993)
				LadyLuck.TrashGoldOK = !LadyLuck.TrashGoldOK;
			else if (info.ButtonID == 992)
				LadyLuck.TrashTokensOK = !LadyLuck.TrashTokensOK;
			else if (info.ButtonID == 990)
			{
				TextRelay tr_Text = info.GetTextEntry( 991 );
				if(tr_Text != null)
				{
					int temp = 0;
					try { temp = Convert.ToInt32( tr_Text.Text,10 ); } 
					catch { from.SendMessage( "Please make sure you wrote only whole numbers." ); }
					if ( temp > 1440 )
						from.SendMessage( 32, "You can't set the number of minutes higher than 1440." );
					else if ( temp > 0 )
					{
						LadyLuck.TokenCostInGold = temp;
						from.SendMessage( 88, "You set the new time before clearing the bag to {0} minutes.", temp );
					}
				}
			}
			else if (info.ButtonID == 988)
			{
				TextRelay tr_Text = info.GetTextEntry( 989 );
				if( tr_Text != null )
				{
					int temp = 0;
					try { temp = Convert.ToInt32( tr_Text.Text,10 ); } 
					catch { from.SendMessage( "Please make sure you wrote only whole numbers." ); }
					if ( temp > 100 )
						from.SendMessage( 32, "You can't reduce the weight by more than 100%!" );
					else if ( temp >= 0 )
					{
						LadyLuck.TokenCostInGold = temp;
						from.SendMessage( 88, "You set the new weight reduction for the bag to {0}% of the total weight.", temp );
					}
				}
			}
			if (info.ButtonID == 6)
				if (OwltrOps[5].Setting)
					CommandSystem.Register( "MissingRecipes", AccessLevel.Player, new CommandEventHandler( Daat99OWLTR.MissingRecipes_OnCommand ) );
				else
					CommandSystem.Entries.Remove("MissingRecipes");
			if (info.ButtonID != 0)
				from.SendGump( new Daat99CustomOWLTRGump(p_From) );
		}
	}

	public class OWLTRbodGump : Gump
	{
		private PlayerMobile pm_From;
		public OWLTRbodGump( PlayerMobile from ) : base(0, 0)
		{
			pm_From = from;
			from.CloseGump(typeof(OWLTRbodGump));
			Resizable=false;
			AddPage(0);
			AddBackground(0, 0, 390, 125, 3600);
			AddLabel(110, 20, 89, @"daat99's OWLTR Bod Gump");

				
			string s_BS = String.Format( "{0}:{1}:{2}", from.NextSmithBulkOrder.Hours, from.NextSmithBulkOrder.Minutes, from.NextSmithBulkOrder.Seconds );
			if (from.NextSmithBulkOrder == TimeSpan.Zero)
			{
				AddButton(25, 43, 5534, 5535, 1, GumpButtonType.Reply, 0);
				AddLabel(95, 45, 69, "Use the button to take blacksmith bod now." );
			}				
			else
				AddLabel(50, 45, 69, "Next Blacksmithy bod will be vailable in: " + s_BS );
				
			string s_TL = String.Format( "{0}:{1}:{2}", from.NextTailorBulkOrder.Hours, from.NextTailorBulkOrder.Minutes, from.NextTailorBulkOrder.Seconds );
			if (from.NextTailorBulkOrder == TimeSpan.Zero)
			{
				AddButton(25, 73, 5534, 5535, 2, GumpButtonType.Reply, 0);
				AddLabel(95, 75, 69, "Use the button to take tailoring bod now." );
			}				
			else
				AddLabel(60, 75, 69, "Next Tailoring bod will be vailable in: " + s_TL );
		}

		public override void OnResponse(NetState state, RelayInfo info)
		{
			Mobile from = state.Mobile;
			switch (info.ButtonID)
			{
				default: from.CloseGump(typeof(OWLTRbodGump)); break;
				case 1:
				{
					if ( pm_From != null && pm_From.NextSmithBulkOrder == TimeSpan.Zero )
					{
						double theirSkill = pm_From.Skills[SkillName.Blacksmith].Base;
						if (theirSkill < 0.1)
						{
							pm_From.SendMessage("You need more Blacksmithy skill to get Blacksmith bods!!!");
							break;
						}
						if ( theirSkill >= 70.1 )
							pm_From.NextSmithBulkOrder = TimeSpan.FromHours( 6.0 );
						else if ( theirSkill >= 50.1 )
							pm_From.NextSmithBulkOrder = TimeSpan.FromHours( 2.0 );
						else
							pm_From.NextSmithBulkOrder = TimeSpan.FromHours( 1.0 );

						if ( theirSkill >= 70.1 && ((theirSkill - 40.0) / 300.0) > Utility.RandomDouble() )
							pm_From.SendGump( new LargeBODAcceptGump( from, new LargeSmithBOD() ) );
						else
						{
							SmallSmithBOD ssb = SmallSmithBOD.CreateRandomFor( from ) as SmallSmithBOD;
							if (ssb == null)
								pm_From.SendMessage(32, "Due to your lack in skills you just lost the bod, you better train before you ask for another one...");
							else
								pm_From.SendGump( new SmallBODAcceptGump( from, ssb ) );
						}
					}
					break;
				}
				case 2:
				{
					if ( pm_From != null && pm_From.NextTailorBulkOrder == TimeSpan.Zero )
					{
						double theirSkill = pm_From.Skills[SkillName.Tailoring].Base;
						if (theirSkill < 0.1)
						{
							pm_From.SendMessage("You need more Tailoring skill to get Tailoring bods!!!");
							break;
						}
						if ( theirSkill >= 70.1 )
							pm_From.NextTailorBulkOrder = TimeSpan.FromHours( 6.0 );
						else if ( theirSkill >= 50.1 )
							pm_From.NextTailorBulkOrder = TimeSpan.FromHours( 2.0 );
						else
							pm_From.NextTailorBulkOrder = TimeSpan.FromHours( 1.0 );

						if ( theirSkill >= 70.1 && ((theirSkill - 40.0) / 300.0) > Utility.RandomDouble() )
							pm_From.SendGump( new LargeBODAcceptGump( from, new LargeTailorBOD() ) );
						else
						{
							SmallTailorBOD stb = SmallTailorBOD.CreateRandomFor( from ) as SmallTailorBOD;
							if (stb == null)
								pm_From.SendMessage(32, "Due to your lack in skills you just lost the bod, you better train before you ask for another one...");
							else
								pm_From.SendGump( new SmallBODAcceptGump( from, stb ) );
						}
					}
					break;
				}
			}
		}
	}
	public class MissingRecipesGump : Gump
	{
		private bool b_ForStaff;
		private PlayerMobile p_From;
		private int i_Page, i_Limit;

		public MissingRecipesGump( PlayerMobile from, int page ) : base( 100, 100 ) 
		{
			p_From = from;
			i_Page = page;
			from.CloseGump(typeof(MissingRecipesGump));

			Resizable=false;
			
			if ( !Daat99OWLTR.StaticHolders.Contains((Mobile)from) )
				return;
			
			NewDaat99Holder dh = Daat99OWLTR.StaticHolders[from] as NewDaat99Holder;
			int count = page * 30, i_Limit = dh.ItemTypeList.Count;
			
			AddPage(0);
			AddBackground(0, 0, 450, 450, 9350);
			AddLabel(40,  20, 2, @"===================");
			AddLabel(80,  30, 2, @" /\");
			AddLabel(41,  40, 2, @" -----/---\-----");
			AddLabel(45,  50, 2, @" \ /     \ /");
			AddLabel(53,  60, 2, @" /       \");
			AddLabel(55,  60, 2, @" \       /");
			AddLabel(44,  70, 2, @" / \     / \");
			AddLabel(42,  80, 2, @" -----\---/-----");
			AddLabel(82,  90, 2, @" \/");
			AddLabel(40, 100, 2, @"===================");
			
			AddButton(285, 80, 5526, 5527, 999, GumpButtonType.Reply, 0); //help
			if (page != 0)
				AddButton(235, 80, 4015, 4016, 1, GumpButtonType.Reply, 0);//previos
			if (count + 30 < i_Limit)
				AddButton(365, 80, 4006, 4007, 2, GumpButtonType.Reply, 0);//next
			
			AddHtml( 180, 50, 240, 20, String.Format( "<basefont color=#000088><center>Missing Crafting Recipes:</center></font>" ), false, false );
			if ( dh.ItemTypeList == null || dh.ItemTypeList.Count < 1 )
				AddHtml( 180, 20, 240, 20, String.Format( "<basefont color=#008800><center>{0} don't need recipes.</center></font>", from.Name ), false, false );
			else
			{
				AddHtml( 180, 20, 240, 20, String.Format( "<basefont color=#008800><center>{0} need {1} recipes.</center></font>", from.Name, dh.ItemTypeList.Count ), false, false );
				AddPage(1);
				for (int i = 0; i < 15; i++)
				{
					if ( count < i_Limit )
					{
						string s_Key = ((Type)dh.ItemTypeList[count]).Name, s_Temp = ((Type)dh.ItemTypeList[count]).Name;
						int i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
						if ( i_Break > -1 )
						{
							s_Key = s_Temp.Substring( 0, i_Break );
							s_Temp = s_Temp.Substring( i_Break );
							i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
							while ( i_Break > -1 )
							{
								s_Key = s_Key + " " + s_Temp.Substring(0, i_Break );
								s_Temp =  s_Temp.Substring( i_Break );
								i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
							}
							if ( s_Temp != null && s_Temp != s_Key )
								s_Key += " " + s_Temp;
						}
						AddHtml( 20, 130 + i*20, 210, 20, String.Format( "<basefont color=#0000ff>{0}. {1}</font>", count + 1, s_Key ), false, false );
					}
					count++;
					if ( count < i_Limit )
					{
						string s_Key = ((Type)dh.ItemTypeList[count]).Name, s_Temp = ((Type)dh.ItemTypeList[count]).Name;
						int i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
						if ( i_Break > -1 )
						{
							s_Key = s_Temp.Substring( 0, i_Break );
							s_Temp = s_Temp.Substring( i_Break );
							i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
							while ( i_Break > -1 )
							{
								s_Key = s_Key + " " + s_Temp.Substring(0, i_Break );
								s_Temp =  s_Temp.Substring( i_Break );
								i_Break = s_Temp.IndexOfAny("ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray(),1);
							}
							if ( s_Temp != null && s_Temp != s_Key )
								s_Key += " " + s_Temp;
						}
						AddHtml( 230, 130 + i*20, 210, 20, String.Format( "<basefont color=#0000ff>{0}. {1}</font>", count + 1, s_Key ), false, false );
					}
					count++;
				}
			}
		}
		public override void OnResponse(NetState state, RelayInfo info)
		{
			Mobile from = state.Mobile;
			int count = i_Page * 30;
			switch (info.ButtonID)
			{
				default: from.CloseGump(typeof(MissingRecipesGump)); break;
				case 1: { from.SendGump( new MissingRecipesGump(p_From, i_Page - 1) ); break; }
				case 2: { from.SendGump( new MissingRecipesGump(p_From, i_Page + 1) ); break; }
				case 999:
				{
					from.LaunchBrowser( "http://www.angelfire.com/trek/daat99/index.html" );
					from.SendGump( new MissingRecipesGump(p_From, i_Page) );
					break;
				}
			}
		}
	}
}	